(*-------------------------------NumWorks.pas--------------------------
 V1.0.236 - 17.12.2001 added ExtractBits, CountBits, BitIsSet,
                             SetBit, ResetBit
 V1.0.235 - 13.12.2001 added HexToInt
*)

unit NumWorks;

interface

uses Windows, SysUtils;

function RoundUp(X: Real): Integer;
function RoundDown(X: Real): Integer;
function RndBetween(RangeMinor, RangeMajor: Integer): Integer;
function HexToInt(HexStr: String): Integer;
function ExtractBits(const Value, Start, Count: Integer): Integer;
function CountBits(const Value: Integer): Integer;
function BitIsSet(w : DWord; Bitnr:integer):Boolean;
procedure SetBit(var w : DWord; Bitnr:integer);
procedure ResetBit(var w : DWord; Bitnr:integer);


implementation

function RoundUp(X: Real): Integer;
begin
   if Trunc(X)<>X then begin
      result:=Trunc(X)+1;
      exit;
   end else result:= Trunc(X);
end;

function RoundDown(X: Real): Integer;
begin
   if Trunc(X)<>X then begin
      result:=Trunc(X)-1;
      exit;
   end else result:= Trunc(X);
end;

function RndBetween(RangeMinor, RangeMajor: Integer): Integer;
var
   Rnd: Integer;
begin
   Randomize;
   Rnd:= Random(RangeMajor);
   while (Rnd < RangeMinor) do Rnd:= Random(RangeMajor);
   result:= Rnd;
end;

function HexToInt(HexStr: String): Integer;
begin
  result:= StrToInt('$' + HexStr);
end;

function ExtractBits(const Value, Start, Count: Integer): Integer;
const
  {basiert auf Guido Gybels, http://www.optimalcode.com/Guido/basmex6.html}
  Mask: array[0..31] of Integer =
            ($01,$03,$07,$0F,$1F,$3F,$7F,$FF,
            $01FF,$03FF,$07FF,$0FFF,$1FFF,$3FFF,$7FFF,$FFFF,
            $01FFFF,$03FFFF,$07FFFF,$0FFFFF,
            $1FFFFF,$3FFFFF,$7FFFFF,$FFFFFF,
            $01FFFFFF,$03FFFFFF,$07FFFFFF,$0FFFFFFF,
            $1FFFFFFF,$3FFFFFFF,$7FFFFFFF,$FFFFFFFF);
asm
  xchg ecx,edx
  test edx,edx
  jnz @@isoke
  xor eax,eax
  jmp @@ending
 @@isoke:
  dec edx
  and edx,31
  shr eax,cl
  and eax,dword ptr [Mask+edx*4]
 @@ending:
end;

function CountBits(const Value: Integer): Integer;
asm
  {basiert auf Guido Gybels, http://www.optimalcode.com/Guido/basmex6.html}
  mov ecx,eax
  xor eax,eax
  test ecx,ecx
  jz @@ending
 @@counting:
  shr ecx,1
  adc eax,0
  test ecx,ecx
  jnz @@counting
 @@ending:
end;

function BitIsSet(w : DWord; Bitnr:integer):Boolean;
begin
   {basiert auf WernerSt, Spotlight Delphi Forum, 17.12.2001}
   result:=(w and (1 shl Bitnr))<>0;
end;

procedure SetBit(var w : DWord; Bitnr:integer);
begin
   {basiert auf WernerSt, Spotlight Delphi Forum, 17.12.2001}
   w:=w or (1 shl Bitnr);
end;

procedure ResetBit(var w : DWord; Bitnr:integer);
begin
   {basiert auf WernerSt, Spotlight Delphi Forum, 17.12.2001}
   w:=w and ($FFFFFFFF xor (1 shl Bitnr));
end;

end.
