unit PrinterWorks;

interface

uses Windows, SysUtils, Messages, Printers, StringWorks;

procedure SetDefaultPrinter(NewDefPrinter : string);
function GetPrinterStrFromIndex(index : integer) : string;
function PRN_PXLPERMM_X(MM: Integer): Integer;
function PRN_PXLPERMM_Y(MM: Integer): Integer;
function PRN_MMToPixelX(Millimeters: Integer): Integer;
function PRN_MMToPixelY(Millimeters: Integer): Integer;

implementation

function GetPrinterStrFromIndex(index : integer) : string;
var
   pri : integer;
   hDeviceMode : THandle;
   Device,Driver,Port : array[0..255] of char;
   s,ResStr : array[0..255] of char;
begin
   pri:=Printer.PrinterIndex;
   Printer.PrinterIndex:=index;
   Printer.GetPrinter(Device,Driver,Port,hDeviceMode);
   GetProfileString('Devices',Device,'',ResStr,255);
   StrCopy (s, Device);
   StrCat (s, ',');
   StrCat (s, ResStr);
   Result:=String(s);
   Printer.PrinterIndex:=pri;
end;

procedure SetDefaultPrinter(NewDefPrinter : string);
var
   ResStr : array[0..255] of char;
begin
   StrPCopy(ResStr,NewdefPrinter);
   WriteProfileString ('windows', 'device', ResStr);
   StrCopy (ResStr, 'windows');
   SendMessage (HWND_BROADCAST, WM_WININICHANGE, 0, LongInt (@ResStr));
end;

function PRN_PXLPERMM_X(MM: Integer): Integer;
var
   xPelsPerInch, xPelsPerMM, xPelsOffset: Extended;
begin
   xPelsPerInch:= GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSX);
   xPelsPerMM:= (xPelsPerInch / 25.4);
   xPelsOffset:= GetDeviceCaps(Printer.Canvas.Handle, PHYSICALOFFSETX);
   result:= Abs(Round(MM * xPelsPerMM - xPelsOffset));
end;

function PRN_PXLPERMM_Y(MM: Integer): Integer;
var
   yPelsPerInch, yPelsPerMM, yPelsOffset: Extended;
begin
   yPelsPerInch:= GetDeviceCaps(Printer.Canvas.Handle, LOGPIXELSY);
   ShowInteger(Round(yPelsPerInch));
   yPelsPerMM:= (yPelsPerInch / 25.4);
   yPelsOffset:= GetDeviceCaps(Printer.Canvas.Handle, PHYSICALOFFSETY);
   result:= Abs(Round(MM * yPelsPerMM - yPelsOffset));
end;

function PRN_MMToPixelX(Millimeters: Integer): Integer;
begin
   result:= PRN_PXLPERMM_X(Millimeters);
end;

function PRN_MMToPixelY(Millimeters: Integer): Integer;
begin
   result:= PRN_PXLPERMM_Y(Millimeters);
end;


end.
